''' Compile: fbc.exe -dll -s gui -fpu sse -fpmode fast -x simth.dll -vec 2

#include once "windows.bi"
#include once "win/ole2.bi"

Union _fsqrt
   tmp As Integer
   value As Single
End Union

#Define BIAS  -  &h4c000

Extern "windows-ms"

    
    '   
    Function Bezie Alias "Bezie"(ByVal t As Double, ByVal x0 As Double, ByVal x1 As Double, ByVal x2 As Double, ByVal x3 As Double ) As Double EXPORT
            Dim As Double T1, T2, T3, T4
            T1 = 1 - t
            T2 = T1 * t * 3
            T3 = t * t
            T4 = T1 * T1
            Bezie = T1 * (T4 * x0 + T2 * x1) + t * (T2 * x2 + T3 * x3)
    End Function
    
    '  
    Function RShift Alias "RShift"(ByVal Value As Long, ByVal bitc As Long) As Long EXPORT
        RShift = Value shr bitc
    End Function
    Function LShift Alias "LShift"(ByVal Value As Long, ByVal bitc As Long) As Long EXPORT
        LShift = Value shl bitc
    End Function

      
    '  XOR   
    Function fvXOR Alias "fvXOR" (ByVal r1 As Byte PTR, ByVal r2 As Byte PTR, ByVal r_out As Byte PTR, ByVal L As Long) As Long EXPORT
        Dim N As Long
        For N = 0 To L - 1
            r_out[n] = r1[n] XOR r2[n]
        Next
        fvXOR = 0
    End Function
    
    '  XOR   
    Function fvXOR2 Alias "fvXOR2" (ByVal r1 As Byte PTR, ByVal r2 As Byte PTR, ByVal L As Long) As Long EXPORT
        Dim N As Long
        For N = 0 To L - 1
            r2[n] = r1[n] XOR r2[n]
        Next
        fvXOR2 = 0
    End Function

    
        '''   
    Function dSQR Alias "dSQR"(ByVal F As Double) As Double
       dSQR = F * F
    End Function
        
    '   
    Public Sub FastFourierTransform(ByVal a As Double PTR, ByVal nn As Long, ByVal InverseFFT As Integer) EXPORT
        Dim ii As Long
        Dim jj As Long
        Dim n As Long
        Dim mmax As Long
        Dim m As Long
        Dim j As Long
        Dim istep As Long
        Dim i As Long
        Dim isign As Long
        Dim invnn As Double
        Dim wtemp As Double
        Dim wr As Double
        Dim wpr As Double
        Dim wpi As Double
        Dim wi As Double
        Dim theta As Double
        Dim tempr As Double
        Dim tempi As Double

        If InverseFFT Then
            isign = -1#
        Else
            isign = 1#
        End If
        n = 2# * nn
        j = 1#
        For ii = 1# To nn Step 1
            i = 2# * ii - 1#
            If j > i Then
                tempr = a[j - 1#]
                tempi = a[j]
                a[j - 1#] = a[i - 1#]
                a[j] = a[i]
                a[i - 1#] = tempr
                a[i] = tempi
            End If
            m = n \ 2#
            Do While m >= 2# AND j > m
                j = j - m
                m = m \ 2#
            Loop
            j = j + m
        Next ii
        mmax = 2#
        Do While n > mmax
            istep = 2# * mmax
            theta = 6.2831853071 / (isign * mmax)
            wtemp = Sin(0.5 * theta)
            wpr =  - 2# * wtemp * wtemp
            wpi = Sin(theta)
            wr = 1#
            wi = 0#
            For ii = 1# To mmax \ 2# Step 1
                m = 2# * ii - 1#
                For jj = 0# To (n - m) \ istep Step 1
                    i = m + jj * istep
                    j = i + mmax
                    tempr = wr * a[j - 1#] - wi * a[j]
                    tempi = wr * a[j] + wi * a[j - 1#]
                    a[j - 1#] = a[i - 1#] - tempr
                    a[j] = a[i] - tempi
                    a[i - 1#] = a[i - 1#] + tempr
                    a[i] = a[i] + tempi
                Next jj
                wtemp = wr
                wr = wr * wpr - wi * wpi + wr
                wi = wi * wpr + wtemp * wpi + wi
            Next ii
            mmax = istep
        Loop
        If InverseFFT Then
            invnn = 1 / nn
            For i = 1# To 2# * nn Step 1
                a[i - 1#] = a[i - 1#] * invnn
            Next i
        End If
    End Sub
    
    '''  
    Function HSize Alias "HSize"(ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Double EXPORT
      Dim n1 As Double, n2 As Double
      n1 = X2 - X1
      n2 = Y2 - Y1
      HSize = Sqr(n1 * n1 + n2 * n2)
    End Function
    '''   
    Function lHSize Alias "lHSize"(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long EXPORT
      Dim n1 As Long, n2 As Long
      n1 = X2 - X1
      n2 = Y2 - Y1
      lHSize = Sqr(n1 * n1 + n2 * n2)
    End Function
    Function XSize Alias "XSize"(ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Double EXPORT
      Dim n1 As Double, n2 As Double
      n1 = X2 - X1
      n2 = Y2 - Y1
      XSize = n1 * n1 + n2 * n2
    End Function
    '''   
    Function lXSize Alias "lXSize"(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long EXPORT
      Dim n1 As Long, n2 As Long
      n1 = X2 - X1
      n2 = Y2 - Y1
      lXSize = n1 * n1 + n2 * n2
    End Function
    '''   ()
    Function FastHSize Alias "FastHSize"(ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Double EXPORT
        FastHSize = (Abs(X2 - X1) + Abs(Y2 - Y1)) * 0.71
    End Function
    '''    ()
    Function lFastHSize Alias "lFastHSize"(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long EXPORT
        lFastHSize = (Abs(X2 - X1) + Abs(Y2 - Y1)) * 0.71
    End Function

    
    '''      4 . 2D  .
    Function sqrDT Alias "sqrDT"(ByVal W As Double, ByVal H As Double, ByVal X As Double, ByVal Y As Double, _
                                ByVal I1 As Double, ByVal I2 As Double, ByVal I3 As Double, ByVal I4 As Double) As Double EXPORT
      Dim N As Double
      N = W - X
      sqrDT = (H * (I1 * N + I2 * X) + Y * (N * (I3 - I1) + X * (I4 - I2))) / (W * H)
    End Function
    '''      2 .  .
    '  0  Max
    Function GradLeaner Alias "GradLeaner"(ByVal Val1 As Double, ByVal Val2 As Double, ByVal MaxV As Double, ByVal Value As Double) As Double EXPORT
        GradLeaner = (Val1 * Value + Val2 * (MaxV - Value)) / MaxV
    End Function
    '  0  1
    Function GradLeanerOne Alias "GradLeanerOne"(ByVal Val1 As Double, ByVal Val2 As Double, ByVal Value As Double) As Double EXPORT
        GradLeanerOne = Val1 * Value + Val2 * (1 - Value)
    End Function
    
    
    '''    Value(0 - Max)
    Function GetRND (ByVal Value As Double, ByVal MaxV As Double) As Byte EXPORT
      If Value > Rnd * MaxV Then
        GetRND = 1
      End If
    End Function
    '''    Value(0 - 1)
    Function GetFastRND Alias "GetFastRND"(ByVal Value As Double) As Byte EXPORT
      If Value > Rnd Then
        GetFastRND = 1
      End If
    End Function


    '''   
    Function Angle Alias "Angle"(ByVal X As Double, ByVal Y As Double, ByVal A As Double, ByVal B As Double) As Double EXPORT
        If X = A Then
            If Y < B Then
                Function = 0
            ElseIf Y > B Then
                Function = 3.14159265358979
            ElseIf Y = B Then
                Function =  - 1.5707963267
            End If
        ElseIf X > A Then
            If Y = B Then
                Function = 4.7123889803
            ElseIf Y > B Then
                Function = 4.7123889803 - Atn((Y - B) / (X - A))
            ElseIf Y < B Then
                Function = Atn((B - Y) / (X - A)) - 1.5707963267
            End If
        ElseIf X < A Then
            If Y = B Then
                Function = 0
            ElseIf Y > B Then
                Function = 1.5707963267 + Atn((Y - B) / (A - X))
            ElseIf Y < B Then
                Function = 1.5707963267 - Atn((B - Y) / (A - X))
            End If
        End If
    End Function

     
    ' SOUND
    '  
    '   .
    Function waveTRIANGLE Alias "waveTRIANGLE" (ByVal X As Double) As Double EXPORT
        waveTRIANGLE = 0.6366197723 * asin(sin(x))
    End Function
    ' SAWTOOTH " "   FreeBasic:
    Function waveSAW Alias "waveSAW" (ByVal X As Double) As Double EXPORT
        waveSAW =  - 2 * (frac(x * 0.15915494309) - 0.5 )
    End Function
    ' SQUARE
    Function waveSQUARE Alias "waveSQUARE" (ByVal X As Double) As Double EXPORT
        waveSQUARE = sgn(sin(x))
    End Function
    '  
    Function waveSINE Alias "waveSINE" (ByVal X As Double) As Double EXPORT
        waveSINE = sin(x)
    End Function
    'PULSE
    Function wavePULSE Alias "wavePULSE" (ByVal X As Double) As Double EXPORT
        wavePULSE = sgn(abs(sin(x * 0.5)) - 0.5)
    End Function

End Extern




